
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) franco morelli<p>
 * Company:      <p>
 * @author franco morelli
 * @version 1.0
 */

import java.lang.*;
import java.net.*;
import java.util.*;
import java.io.*;

public class ServitoreMaster extends Thread {
  public Map Tabella=Collections.synchronizedMap(new HashMap());
  public Map Onwriting=Collections.synchronizedMap(new HashMap());
  public DelCommands Delcomm=new DelCommands();
  public byte[] rcvbuff=new byte[100];
  public DatagramPacket dprcv=new DatagramPacket(rcvbuff,rcvbuff.length);
  public DatagramSocket rcvsock=null;
  public Socket restartsock=null;
  public ServerSocket aggsock=null;
  public UpdaterThread update;
  public boolean bandiera;
  public boolean rivers=false;
  int segnale;
  boolean incons=false;
  public ServitoreMaster(ThreadGroup g) {
    super(g,"Padre");
  }

  public synchronized boolean inconsistente(){
   return incons;
  }


  public synchronized void set_inconsistente(boolean b){
   incons=b;
  }

  public synchronized void fermatutto(){
   segnale=1;
   Frame1.jTextPane1.setText("Terminato               ");
   try{if (restartsock!=null) restartsock.close();}
   catch(IOException ioex){System.exit(-9);}
   try{if (aggsock!=null) aggsock.close();}
   catch(IOException ioex){System.exit(-9);}
    try{
     if (rcvsock!=null) rcvsock.close();
     (this.getThreadGroup()).interrupt();
    }
     catch(NullPointerException npe){}

  }

  public synchronized void setFlag(boolean f){
   bandiera=f;
  }
  public synchronized boolean getriv(){
   return rivers;
  }
  public synchronized void setriv(boolean b){
    rivers=b;
  }
  public void run() {
    this.setFlag(true);
    segnale=0;
     try{
      Frame1.jTextPane1.setText("Tentativo di connesione allo slave");
      restartsock=new Socket(Master.iaslave,Master.agg_slaport);
      Frame1.jTextPane1.setText("Connessione riuscita...Avvio aggiornamento");
      ObjectInputStream in=new ObjectInputStream(restartsock.getInputStream());
      try{
       Tabella=(HashMap)in.readObject();
      }
      catch(ClassNotFoundException er){
       try{restartsock.close();}
       catch(Exception ec){System.exit(-1);}
       System.out.println(er.toString());
       System.exit(-1);
      }
      if (segnale==1) return;
      Frame1.jTextPane1.setText("Fine aggiornamento...In Servizio");
      set_inconsistente(true);
     }
    catch(IOException e){
      try{restartsock.close();}
      catch(Exception ec){}
      if (segnale==1) return;
      Frame1.jTextPane1.setText("Impossibile connettersi allo slave    Avvio come prima volta...");
      long in=Master.min;
      for(in=Master.min;in<=Master.max;in++){
      String nom=new String("pippo"+in);
       Object nomeserv=nom;
       Object indice=new Long(in*3);
       Object po=new Long(in*1);
       Object val=new String(indice.toString()+'-'+po.toString());
       Tabella.put(nomeserv,val);
      }
    }
    System.out.println("Fine creazione tabella");
    String s;
    String command;
    try{aggsock=new ServerSocket(Master.agg_masport);
    }
    catch(Exception se){
     System.out.println(se.toString());
     System.exit(-3);
    }
    UpdaterThread update=new UpdaterThread(aggsock);
    update.start();
    try{rcvsock=new DatagramSocket(Master.masport);
        rcvsock.setReceiveBufferSize(10000); }
    catch(SocketException se){
    System.out.println("Errore "+se.toString() );
    System.exit(-3);}
    int errore=0;
    while (errore==0){
      try {rcvsock.receive(dprcv);}
      catch (IOException ioe){
       errore=1;
       continue;
      }
      s=new String(dprcv.getData(),0,dprcv.getLength());

      //Frame1.jTextPane1.setText(s);
      command=s.substring(0,3);

      System.out.println("ComandoRicevuto:"+s);
      dprcv.setLength(100);//Risetto la lunghezza di dprcv perch altrimenti rimane settata all'ultima lunghezza assunta
      if (command.compareTo("Loo")==0) {LooThread lookup=new LooThread(dprcv,s);
                                        continue;
                                        }
      if ((command.compareTo("Ins")==0)&&(!inconsistente())) {InsThread insert=new InsThread(dprcv,s);
                                                            continue;
                                                            }
      if ((command.compareTo("Del")==0)&&(!inconsistente())) {DelThread delete=new DelThread(dprcv,s);
                                                            continue;
                                                            }
      if (command.compareTo("Dec")==0) {DecThread Delc=new DecThread(dprcv,s);
                                        continue;
                                        }
      if (command.compareTo("Inc")==0) {IncThread Insc=new IncThread(dprcv,s);
                                        continue;
                                        }
      if ((command.compareTo("Lod")==0)&&(!inconsistente())) {LodThread lookupd=new LodThread(dprcv,s);
                                                            continue;
                                                           }
      if (command.compareTo("Chk")==0) {ChkThread check=new ChkThread(dprcv,s);
                                        continue;
                                        }
      if (command.compareTo("Fin")==0) {set_inconsistente(false);}



    }

  }
public class InsThread extends Thread{
  DatagramPacket lineacom;
  DatagramSocket sock=null;
  Talker talk;
  InetAddress iacliente;
  int portacliente;
  String st;
  int i;
  public InsThread(DatagramPacket dp,String trad) {
   st=new String(trad);
   lineacom=dp;
   iacliente=lineacom.getAddress();
   portacliente=lineacom.getPort();
   this.start();
  }
  public void run(){
    System.out.println("inizio thread");
    try{sock=new DatagramSocket();}
    catch(SocketException ex){
     System.out.println("Errore creazione socket");
     System.exit(-3);}
    try{talk=new Talker(sock,Master.timeout);}
    catch (SocketException e){
      System.out.println("Errore creazione talk");
      System.exit(-6);}
    String nome,valore,porta,reply;
    Object repfromcouple;
    i=st.lastIndexOf('-');
    porta=st.substring(i+1);
    nome=st.substring(4,i);
    if (Tabella.containsKey(nome)){
     valore=(Tabella.get(nome)).toString();
     reply=new String(nome+'-'+valore);
     reply="Esiste "+reply;
     talk.reply(reply,iacliente,portacliente);
     sock.close();
     return;
    }
    if (Onwriting.containsKey(nome)){
     valore=(Onwriting.get(nome)).toString();
     reply=new String("Onwrit "+nome+'-'+valore);
     talk.reply(reply,iacliente,portacliente);
     sock.close();

     return;
    }
    valore=new String(iacliente.toString().substring((iacliente.toString().lastIndexOf("/"))+1)+'-'+porta);
    Onwriting.put(nome,valore);
    String coma=new String("Lod-"+nome);
    repfromcouple=talk.doubleask(coma,Master.iamaster2,Master.mas2port,Master.iaslave2,Master.sla2port);
    if ((repfromcouple.getClass().toString()).compareTo("class java.lang.String")==0){
     Onwriting.remove(nome);
     reply="Impossibile contattare l'altra coppia";
     talk.reply(reply,iacliente,portacliente);
     sock.close();
     return;
    }
    String rispostacoppia=new String(((DatagramPacket)repfromcouple).getData(),0,((DatagramPacket)repfromcouple).getLength());
    String first=rispostacoppia.substring(0,6);
    if ((first.compareTo("Esiste")==0) || ((first.compareTo("Onwrit")==0) && (Master.prior==0))){
     Onwriting.remove(nome);
     talk.reply(rispostacoppia,iacliente,portacliente);//Propaga la risposta dell'altra coppia!
     sock.close();
     return;
    }

    if( ((first.compareTo("Assent")==0) && (!getriv())) || ((first.compareTo("Onwrit")==0) && (Master.prior==1) && !getriv())){
     Tabella.put(nome,valore);
     Onwriting.remove(nome);
     talk.reply("OK",iacliente,portacliente);
     String com=new String("Inc"+'-'+nome+'-'+valore);
     talk.ask(com,Master.iaslave,Master.slaport); //Aggiorna la copia calda
     sock.close();
     return;
    }
    if( ((first.compareTo("Assent")==0) && getriv()) || ((first.compareTo("Onwrit")==0) && (Master.prior==1) && getriv()) ){
     Tabella.put(nome,valore);
     Onwriting.remove(nome);
     talk.reply("OK",iacliente,portacliente);
     String com1=new String("Inc"+'-'+nome+'-'+valore);
     Delcomm.add(com1);
     sock.close();
     return;
    }
    if ((first.compareTo("Onwrit")==0) && (Master.prior==0)){
     Onwriting.remove(nome);
     talk.reply("Esiste ",iacliente,portacliente);
     sock.close();
     return;
    }
  }//Fine run
}//fine classe annidata InsThread

public class DelThread extends Thread{
 DatagramPacket lineacom;
 DatagramSocket sock=null;
 Talker talk;
 InetAddress iacliente;
 int portacliente;
 String st;
 Object rep;
 public DelThread(DatagramPacket dp,String trad){
   st=new String(trad);
   lineacom=dp;
   iacliente=lineacom.getAddress();
   portacliente=lineacom.getPort();
   this.start();
 }
 public void run(){
    try{sock=new DatagramSocket();}
   catch(SocketException ex){
    System.out.println("Errore creazione socket");
    System.exit(-3);}
   try{talk=new Talker(sock,Master.timeout);}
   catch (SocketException e){
    System.out.println("Errore creazione talk");
    System.exit(-6);}
    String nome,valore,porta,reply;
    Object repfromcouple;
    nome=st.substring(4);
    if (!Tabella.containsKey(nome)){
     talk.reply("Assente in questo dominio",iacliente,portacliente);
     sock.close();
     return;
    }

    talk.reply("OK",iacliente,portacliente);
    String coma=new String("Dec-"+nome+'-'+Tabella.get(nome));
    Tabella.remove(nome);
    if (getriv()) {
    Delcomm.add(coma);
    }
    else {rep=talk.ask(coma,Master.iaslave,Master.slaport);}
    sock.close();
 }

}//Fine classe annidata DelThread

public class LooThread extends Thread{
 DatagramPacket lineacom;
 DatagramSocket sock=null;
 Talker talk;
 InetAddress iacliente;
 int portacliente;
 String st;
 public LooThread(DatagramPacket dp,String trad){
   st=new String(trad);
   lineacom=dp;
   iacliente=lineacom.getAddress();
   portacliente=lineacom.getPort();
   this.start();
 }
  public void run(){
    try{sock=new DatagramSocket();}
    catch(SocketException ex){
    System.out.println("Errore creazione socket");
    System.exit(-3);}
    try{talk=new Talker(sock,Master.timeout);}
    catch (SocketException e){
    System.out.println("Errore creazione talk");
    System.exit(-6);
    }
    String nome,valore,porta,reply;
    Object repfromcouple;
    nome=st.substring(4);
    if (Tabella.containsKey(nome)){
     String risp=new String("Esiste "+nome+' '+Tabella.get(nome).toString());
     talk.reply(risp,iacliente,portacliente);
     sock.close();
     return;
    }
    String coma=new String("Lod-"+nome);
    repfromcouple=talk.doubleask(coma,Master.iamaster2,Master.mas2port,Master.iaslave2,Master.sla2port);
    if ((repfromcouple.getClass().toString()).compareTo("class java.lang.String")==0){
     reply="Impossibile contattare l'altra coppia";
     talk.reply(reply,iacliente,portacliente);
     sock.close();
     return;
    }
    String rispostacoppia=new String(((DatagramPacket)repfromcouple).getData(),0,((DatagramPacket)repfromcouple).getLength());
    String first=rispostacoppia.substring(0,6);

    if ((first.compareTo("Esiste")==0) ){
     talk.reply(rispostacoppia,iacliente,portacliente);//Propaga la risposta dell'altra coppia!
     sock.close();
     return;
    }
    if( (first.compareTo("Onwrit")==0) ||(first.compareTo("Assent")==0)){
     reply="Assente";
     talk.reply(reply,iacliente,portacliente);
     sock.close();
     return;
    }
    sock.close();
 }

}//Fine classe annidata LooThread

public class LodThread extends Thread{
  DatagramPacket lineacom;
  DatagramSocket sock=null;
  Talker talk;
  InetAddress iacliente;
  int portacliente;
  String st;
  public LodThread(DatagramPacket dp,String trad){
    st=new String(trad);
    lineacom=dp;
    iacliente=lineacom.getAddress();
    portacliente=lineacom.getPort();
    this.start();
  }
  public void run(){
    try{sock=new DatagramSocket();}
    catch(SocketException ex){
    System.out.println("Errore creazione socket");
    System.exit(-3);}
    try{talk=new Talker(sock,Master.timeout);}
    catch (SocketException e){
    System.out.println("Errore creazione talk");
    System.exit(-6);
    }
    String nome,valore,porta,reply;
    nome=st.substring(4);
    if (Tabella.containsKey(nome)){
     String risp=new String("Esiste "+nome+'-'+Tabella.get(nome).toString());
     talk.reply(risp,iacliente,portacliente);
     sock.close();
     return;
    }
    if (Onwriting.containsKey(nome)){
     valore=(Onwriting.get(nome)).toString();
     reply=new String("Onwrit"+nome+'-'+valore);
     talk.reply(reply,iacliente,portacliente);
     sock.close();
     return;
    }
    talk.reply("Assent",iacliente,portacliente);
    sock.close();
  }//Fine run
}//Fine classe annidata LodThread

public class IncThread extends Thread{
  DatagramPacket lineacom;
  DatagramSocket sock=null;
  Talker talk;
  InetAddress iacliente;
  int portacliente;
  String st;
  int i;
  public IncThread(DatagramPacket dp,String trad) {
   this.setPriority(this.MAX_PRIORITY); //priorit massima per diminuire il tempo di incosistenza della tabella
   st=new String(trad);
   lineacom=dp;
   iacliente=lineacom.getAddress();
   portacliente=lineacom.getPort();
   this.start();
  }
  public void run(){
   System.out.println("inizio thread");
   try{sock=new DatagramSocket();}
   catch(SocketException ex){
    System.out.println("Errore creazione socket");
    System.exit(-3);
   }
   try{talk=new Talker(sock,Master.timeout);}
   catch (SocketException e){
     System.out.println("Errore creazione talk");
     System.exit(-6);
   }
   String nome,valore;
   String nomevalore=st.substring(4);
   nome=nomevalore.substring(0,nomevalore.indexOf('-'));
   valore=nomevalore.substring(nomevalore.indexOf('-')+1);
   Tabella.put(nome,valore); //pu sovrascrivere
   talk.reply("OK",iacliente,portacliente);
   sock.close();
  } //fine run
}//Fine classe annidata IncThread

public class DecThread extends Thread{
  DatagramPacket lineacom;
  DatagramSocket sock=null;
  Talker talk;
  InetAddress iacliente;
  int portacliente;
  String st;
  int i;
  public DecThread(DatagramPacket dp,String trad) {
   this.setPriority(this.MAX_PRIORITY); //priorit massima per diminuire il tempo di incosistenza della tabella
   st=new String(trad);
   lineacom=dp;
   iacliente=lineacom.getAddress();
   portacliente=lineacom.getPort();
   this.start();
  }
 public void run(){
   System.out.println("inizio thread");
   try{sock=new DatagramSocket();}
   catch(SocketException ex){
    System.out.println("Errore creazione socket");
    System.exit(-3);
   }
   try{talk=new Talker(sock,Master.timeout);}
   catch (SocketException e){
     System.out.println("Errore creazione talk");
     System.exit(-6);
   }
   String nome,valore;
   String nomevalore=st.substring(4);
   nome=nomevalore.substring(0,nomevalore.indexOf('-'));
   valore=nomevalore.substring(nomevalore.indexOf('-')+1);
   if( (Tabella.containsKey(nome)) && (Tabella.get(nome).toString().compareTo(valore)==0) ){
    Tabella.remove(nome);
   }
   talk.reply("OK",iacliente,portacliente);
   sock.close();
  } //fine run
}//Fine classe annidata Decthread

public class ChkThread extends Thread{
  DatagramPacket lineacom;
  DatagramSocket sock=null;
  Talker talk;
  InetAddress iacliente;
  int portacliente;
  String st;
  int i;
  public ChkThread(DatagramPacket dp,String trad) {

   st=new String(trad);
   lineacom=dp;
   iacliente=lineacom.getAddress();
   portacliente=lineacom.getPort();
   this.start();
  }
  public void run(){
   System.out.println("inizio thread");
   try{sock=new DatagramSocket();}
   catch(SocketException ex){
    System.out.println("Errore creazione socket");
    System.exit(-3);
   }
   try{talk=new Talker(sock,Master.timeout);}
   catch (SocketException e){
     System.out.println("Errore creazione talk");
     System.exit(-6);
   }
   talk.reply("OK",iacliente,portacliente);
  }
}//Fine classe annidata ChkThread

public class UpdaterThread extends Thread{
 ServerSocket sockascolto;
 Socket servsock;
 Map copiatabella=new HashMap();
 Talker taalker;
 public UpdaterThread(ServerSocket s){
  sockascolto=s;
 }
 public void run(){
  Talker talker=null;
  try{
     talker=new Talker(Master.timeout);
     }
  catch(SocketException sexc){}
  int err=0;
  while(err==0){
    try{
     servsock=sockascolto.accept();
    }
    catch(IOException ioexc){
     err=1;
     continue;

    }
    System.out.println("Richiesta di connessione accettata");
    copiatabella.putAll(Tabella);
    setriv(true);
    try{
      ObjectOutputStream out=new ObjectOutputStream(servsock.getOutputStream());
      out.writeObject(copiatabella);
    }
    catch(Exception e){
    System.out.println("Caduta slave durante l'aggiornamento...");
    setriv(false);
    continue;
    }
    setriv(false);
    int i=1;
    try{
     sleep(1000);
    }
    catch(InterruptedException iue){System.exit(-1090);}
    Object r=new String();
    String c;

    while (!Delcomm.isempty()){
     c=Delcomm.remove(Delcomm.size()-1);
     r="";
     while((r.getClass().toString()).compareTo("class java.lang.String")==0)  {
       r=talker.ask(c,Master.iaslave,Master.slaport);
     }
     i++;
    }
    copiatabella.clear();
  }
 }
}//Fine classe annidata UpdaterThread
}